/* WindowIcon.c generated by valac 0.44.11, the Vala compiler
 * generated from WindowIcon.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <clutter/clutter.h>
#include <glib-object.h>
#include <meta/window.h>
#include <glib.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>

#define GALA_TYPE_WINDOW_ICON (gala_window_icon_get_type ())
#define GALA_WINDOW_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_ICON, GalaWindowIcon))
#define GALA_WINDOW_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_ICON, GalaWindowIconClass))
#define GALA_IS_WINDOW_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_ICON))
#define GALA_IS_WINDOW_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_ICON))
#define GALA_WINDOW_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_ICON, GalaWindowIconClass))

typedef struct _GalaWindowIcon GalaWindowIcon;
typedef struct _GalaWindowIconClass GalaWindowIconClass;
typedef struct _GalaWindowIconPrivate GalaWindowIconPrivate;
enum  {
	GALA_WINDOW_ICON_0_PROPERTY,
	GALA_WINDOW_ICON_WINDOW_PROPERTY,
	GALA_WINDOW_ICON_ICON_SIZE_PROPERTY,
	GALA_WINDOW_ICON_SCALE_PROPERTY,
	GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY,
	GALA_WINDOW_ICON_NUM_PROPERTIES
};
static GParamSpec* gala_window_icon_properties[GALA_WINDOW_ICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GalaWindowIcon {
	ClutterTexture parent_instance;
	GalaWindowIconPrivate * priv;
};

struct _GalaWindowIconClass {
	ClutterTextureClass parent_class;
};

struct _GalaWindowIconPrivate {
	MetaWindow* _window;
	gint _icon_size;
	gint _scale;
	gboolean _destroy_on_unmanaged;
	gboolean loaded;
	guint32 xid;
};

static gint GalaWindowIcon_private_offset;
static gpointer gala_window_icon_parent_class = NULL;
static BamfMatcher* gala_window_icon_matcher;
static BamfMatcher* gala_window_icon_matcher = NULL;

GType gala_window_icon_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowIcon, g_object_unref)
static void gala_window_icon_retry_load (GalaWindowIcon* self,
                                  BamfView* view);
static void _gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                            BamfView* object,
                                                            gpointer self);
GalaWindowIcon* gala_window_icon_new (MetaWindow* window,
                                      gint icon_size,
                                      gint scale,
                                      gboolean destroy_on_unmanaged);
GalaWindowIcon* gala_window_icon_construct (GType object_type,
                                            MetaWindow* window,
                                            gint icon_size,
                                            gint scale,
                                            gboolean destroy_on_unmanaged);
static void gala_window_icon_update_texture (GalaWindowIcon* self,
                                      gboolean initial);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid,
                                        gint size,
                                        gint scale,
                                        gboolean ignore_cache);
gint gala_window_icon_get_icon_size (GalaWindowIcon* self);
gint gala_window_icon_get_scale (GalaWindowIcon* self);
static void gala_window_icon_unmanaged (GalaWindowIcon* self,
                                 MetaWindow* window);
MetaWindow* gala_window_icon_get_window (GalaWindowIcon* self);
static void gala_window_icon_set_window (GalaWindowIcon* self,
                                  MetaWindow* value);
static void gala_window_icon_set_icon_size (GalaWindowIcon* self,
                                     gint value);
static void gala_window_icon_set_scale (GalaWindowIcon* self,
                                 gint value);
gboolean gala_window_icon_get_destroy_on_unmanaged (GalaWindowIcon* self);
void gala_window_icon_set_destroy_on_unmanaged (GalaWindowIcon* self,
                                                gboolean value);
static void _gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender,
                                                        gpointer self);
static GObject * gala_window_icon_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void gala_window_icon_finalize (GObject * obj);
static void _vala_gala_window_icon_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_gala_window_icon_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
gala_window_icon_get_instance_private (GalaWindowIcon* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowIcon_private_offset);
}

static void
_gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                       BamfView* object,
                                                       gpointer self)
{
	gala_window_icon_retry_load ((GalaWindowIcon*) self, object);
}

/**
         * Creates a new WindowIcon
         *
         * @param window               The window for which to create the icon
         * @param icon_size            The size of the icon in pixels
         * @param scale                The desired scale of the icon
         * @param destroy_on_unmanaged see destroy_on_unmanaged property
         */
GalaWindowIcon*
gala_window_icon_construct (GType object_type,
                            MetaWindow* window,
                            gint icon_size,
                            gint scale,
                            gboolean destroy_on_unmanaged)
{
	GalaWindowIcon * self = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (GalaWindowIcon*) g_object_new (object_type, "window", window, "icon-size", icon_size, "destroy-on-unmanaged", destroy_on_unmanaged, "scale", scale, NULL);
	return self;
}

GalaWindowIcon*
gala_window_icon_new (MetaWindow* window,
                      gint icon_size,
                      gint scale,
                      gboolean destroy_on_unmanaged)
{
	return gala_window_icon_construct (GALA_TYPE_WINDOW_ICON, window, icon_size, scale, destroy_on_unmanaged);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gala_window_icon_retry_load (GalaWindowIcon* self,
                             BamfView* view)
{
	BamfApplication* app = NULL;
	BamfMatcher* _tmp0_;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	BamfMatcher* _tmp3_;
	guint _tmp4_;
	BamfApplication* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	_tmp0_ = gala_window_icon_matcher;
	_tmp1_ = bamf_matcher_get_application_for_xid (_tmp0_, self->priv->xid);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	app = _tmp2_;
	self->priv->loaded = TRUE;
	_tmp3_ = gala_window_icon_matcher;
	g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp4_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
	_tmp5_ = app;
	if (_tmp5_ == NULL) {
		_g_object_unref0 (app);
		return;
	}
	gala_window_icon_update_texture (self, FALSE);
	_g_object_unref0 (app);
}

static void
gala_window_icon_update_texture (GalaWindowIcon* self,
                                 gboolean initial)
{
	GdkPixbuf* pixbuf = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_icon_size;
	_tmp1_ = self->priv->_scale;
	_tmp2_ = gala_utils_get_icon_for_xid (self->priv->xid, _tmp0_, _tmp1_, !initial);
	pixbuf = _tmp2_;
	{
		gint _tmp3_ = 0;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		guint8* _tmp6_;
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_;
		_tmp4_ = pixbuf;
		if (gdk_pixbuf_get_has_alpha (_tmp4_)) {
			_tmp3_ = 4;
		} else {
			_tmp3_ = 3;
		}
		_tmp5_ = pixbuf;
		_tmp6_ = gdk_pixbuf_get_pixels (_tmp5_);
		_tmp7_ = pixbuf;
		_tmp8_ = pixbuf;
		_tmp9_ = pixbuf;
		_tmp10_ = pixbuf;
		clutter_texture_set_from_rgb_data ((ClutterTexture*) self, _tmp6_, gdk_pixbuf_get_has_alpha (_tmp7_), gdk_pixbuf_get_width (_tmp8_), gdk_pixbuf_get_height (_tmp9_), gdk_pixbuf_get_rowstride (_tmp10_), _tmp3_, 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch5_g_error;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (pixbuf);
}

static void
gala_window_icon_unmanaged (GalaWindowIcon* self,
                            MetaWindow* window)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	clutter_actor_destroy ((ClutterActor*) self);
}

MetaWindow*
gala_window_icon_get_window (GalaWindowIcon* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
gala_window_icon_set_window (GalaWindowIcon* self,
                             MetaWindow* value)
{
	g_return_if_fail (self != NULL);
	if (gala_window_icon_get_window (self) != value) {
		MetaWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW_PROPERTY]);
	}
}

gint
gala_window_icon_get_icon_size (GalaWindowIcon* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_icon_size;
	return result;
}

static void
gala_window_icon_set_icon_size (GalaWindowIcon* self,
                                gint value)
{
	g_return_if_fail (self != NULL);
	if (gala_window_icon_get_icon_size (self) != value) {
		self->priv->_icon_size = value;
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE_PROPERTY]);
	}
}

gint
gala_window_icon_get_scale (GalaWindowIcon* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_scale;
	return result;
}

static void
gala_window_icon_set_scale (GalaWindowIcon* self,
                            gint value)
{
	g_return_if_fail (self != NULL);
	if (gala_window_icon_get_scale (self) != value) {
		self->priv->_scale = value;
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_SCALE_PROPERTY]);
	}
}

gboolean
gala_window_icon_get_destroy_on_unmanaged (GalaWindowIcon* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_destroy_on_unmanaged;
	return result;
}

static void
_gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender,
                                                   gpointer self)
{
	gala_window_icon_unmanaged ((GalaWindowIcon*) self, _sender);
}

void
gala_window_icon_set_destroy_on_unmanaged (GalaWindowIcon* self,
                                           gboolean value)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_destroy_on_unmanaged == value) {
		return;
	}
	self->priv->_destroy_on_unmanaged = value;
	if (self->priv->_destroy_on_unmanaged) {
		MetaWindow* _tmp0_;
		_tmp0_ = self->priv->_window;
		g_signal_connect_object (_tmp0_, "unmanaged", (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self, 0);
	} else {
		MetaWindow* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->_window;
		g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self);
	}
	g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY]);
}

static GObject *
gala_window_icon_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowIcon * self;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	MetaWindow* _tmp4_;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp5_;
	BamfApplication* _tmp6_;
	BamfApplication* _tmp7_;
	BamfApplication* _tmp8_;
	parent_class = G_OBJECT_CLASS (gala_window_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
	_tmp0_ = self->priv->_icon_size;
	_tmp1_ = self->priv->_scale;
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) (_tmp0_ * _tmp1_));
	_tmp2_ = self->priv->_icon_size;
	_tmp3_ = self->priv->_scale;
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) (_tmp2_ * _tmp3_));
	_tmp4_ = self->priv->_window;
	self->priv->xid = (guint32) meta_window_get_xwindow (_tmp4_);
	_tmp5_ = gala_window_icon_matcher;
	_tmp6_ = bamf_matcher_get_application_for_xid (_tmp5_, self->priv->xid);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	app = _tmp7_;
	_tmp8_ = app;
	if (_tmp8_ == NULL) {
		BamfMatcher* _tmp9_;
		_tmp9_ = gala_window_icon_matcher;
		g_signal_connect_object (_tmp9_, "view-opened", (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self, 0);
	} else {
		self->priv->loaded = TRUE;
	}
	gala_window_icon_update_texture (self, TRUE);
	_g_object_unref0 (app);
	return obj;
}

static void
gala_window_icon_class_init (GalaWindowIconClass * klass,
                             gpointer klass_data)
{
	BamfMatcher* _tmp0_;
	gala_window_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaWindowIcon_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_icon_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_window_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_window_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_WINDOW_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_ICON_SIZE_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_SCALE_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_SCALE_PROPERTY] = g_param_spec_int ("scale", "scale", "scale", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * If set to true, the SafeWindowClone will destroy itself when the connected
	         * window is unmanaged
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY] = g_param_spec_boolean ("destroy-on-unmanaged", "destroy-on-unmanaged", "destroy-on-unmanaged", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	_tmp0_ = bamf_matcher_get_default ();
	_g_object_unref0 (gala_window_icon_matcher);
	gala_window_icon_matcher = _tmp0_;
}

static void
gala_window_icon_instance_init (GalaWindowIcon * self,
                                gpointer klass)
{
	self->priv = gala_window_icon_get_instance_private (self);
	self->priv->_destroy_on_unmanaged = FALSE;
	self->priv->loaded = FALSE;
}

static void
gala_window_icon_finalize (GObject * obj)
{
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
	if (!self->priv->loaded) {
		BamfMatcher* _tmp0_;
		guint _tmp1_;
		_tmp0_ = gala_window_icon_matcher;
		g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp1_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
	}
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (gala_window_icon_parent_class)->finalize (obj);
}

/**
     * Creates a new ClutterTexture with an icon for the window at the given size.
     * This is recommended way to grab an icon for a window as this method will make
     * sure the icon is updated if it becomes available at a later point.
     */
GType
gala_window_icon_get_type (void)
{
	static volatile gsize gala_window_icon_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowIcon), 0, (GInstanceInitFunc) gala_window_icon_instance_init, NULL };
		GType gala_window_icon_type_id;
		gala_window_icon_type_id = g_type_register_static (clutter_texture_get_type (), "GalaWindowIcon", &g_define_type_info, 0);
		GalaWindowIcon_private_offset = g_type_add_instance_private (gala_window_icon_type_id, sizeof (GalaWindowIconPrivate));
		g_once_init_leave (&gala_window_icon_type_id__volatile, gala_window_icon_type_id);
	}
	return gala_window_icon_type_id__volatile;
}

static void
_vala_gala_window_icon_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
	switch (property_id) {
		case GALA_WINDOW_ICON_WINDOW_PROPERTY:
		g_value_set_object (value, gala_window_icon_get_window (self));
		break;
		case GALA_WINDOW_ICON_ICON_SIZE_PROPERTY:
		g_value_set_int (value, gala_window_icon_get_icon_size (self));
		break;
		case GALA_WINDOW_ICON_SCALE_PROPERTY:
		g_value_set_int (value, gala_window_icon_get_scale (self));
		break;
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY:
		g_value_set_boolean (value, gala_window_icon_get_destroy_on_unmanaged (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_window_icon_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
	switch (property_id) {
		case GALA_WINDOW_ICON_WINDOW_PROPERTY:
		gala_window_icon_set_window (self, g_value_get_object (value));
		break;
		case GALA_WINDOW_ICON_ICON_SIZE_PROPERTY:
		gala_window_icon_set_icon_size (self, g_value_get_int (value));
		break;
		case GALA_WINDOW_ICON_SCALE_PROPERTY:
		gala_window_icon_set_scale (self, g_value_get_int (value));
		break;
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY:
		gala_window_icon_set_destroy_on_unmanaged (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

